package fineday.UDPEchoAndroid;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.io.IOException;

public class UDPEchoAndroid extends Activity  implements View.OnClickListener{
	private TextView textview1;
	private Button button1, button2, button3;
	private EditText edittext1;
	private String server = "192.168.11.4";
	private int port = 8000;
	private static final int sizeBuf = 64;
	private InetAddress serverAddress;
	private DatagramSocket socket;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        textview1 = (TextView)this.findViewById(R.id.textView1);
        textview1.setText("UDPEchoAndroid");
        // Button
        button1 = (Button)this.findViewById(R.id.button1);
        button1.setOnClickListener(this);
        button2 = (Button)this.findViewById(R.id.button2);
        button2.setOnClickListener(this);
        button3 = (Button)this.findViewById(R.id.button3);
        button3.setOnClickListener(this);
        // EditText
        edittext1 = (EditText)this.findViewById(R.id.editText1);
    }
    public void onClick(View arg0){
    	int size = 0;
   	    if (arg0 == button1){
    		try{
            	serverAddress = InetAddress.getByName(server);
            	socket = new DatagramSocket();
            	printString("created");
    		} catch (Exception e){
    			printString("fail Create");
    		}
    	}
    	if (arg0 == button2){
    		try{
    			socket.close();
    			socket = null;
    			printString("closed");
    		} catch (Exception e) {
    			printString("fail close");
    		}
    	}
    	if (arg0 == button3){
    		// M
    		try {
				byte[] w = edittext1.getText().toString().getBytes("UTF8");
				size = w.length;    			
    			
				DatagramPacket sendPacket = new DatagramPacket(w, size, serverAddress, port);
				socket.send(sendPacket);
				printString("SEND: " + edittext1.getText().toString());
			} catch (IOException e) {
				e.printStackTrace();
				printString("send fail");
			}
			// M
			byte[] u = new byte[sizeBuf];
    		try {
    			DatagramPacket receivePacket = new DatagramPacket(u, u.length);
    			socket.receive(receivePacket);
				printString(new String(u, 0, receivePacket.getLength(), "UTF8"));
			} catch (IOException e) {
				e.printStackTrace();
				printString("receive fail");
			}
    	}
    }
    private void printString(final String str){
    	textview1.setText(str + "\n" + textview1.getText());
    }
}
