package fineday.UDPAndroid;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.TextView;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.io.IOException;

public class UDPAndroidActivity extends Activity implements View.OnClickListener{
	private TextView textview1;
	private Button button1, button2, button3, button4, button5, button6, button7;
	private String server = "192.168.11.5";
	private InetAddress serverAddress;
	private int port = 8000;
	private DatagramSocket socket;
	private Thread rcvThread;
	public Logger logger;

	int flag;
    final char magic1 = '@';
    final char magic2 = '}';
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        // TextView
        textview1 = (TextView)this.findViewById(R.id.textView1);
        textview1.setText("UDPThreadAndroid");
        // Button
        button1 = (Button)this.findViewById(R.id.button1);
        button1.setOnClickListener(this);
        button2 = (Button)this.findViewById(R.id.button2);
        button2.setOnClickListener(this);
        button3 = (Button)this.findViewById(R.id.button3);
        button3.setOnClickListener(this);
        button4 = (Button)this.findViewById(R.id.button4);
        button4.setOnClickListener(this);
        button5 = (Button)this.findViewById(R.id.button5);
        button5.setOnClickListener(this);
        button6 = (Button)this.findViewById(R.id.button6);
        button6.setOnClickListener(this);
        button7 = (Button)this.findViewById(R.id.button7);
        button7.setOnClickListener(this);
        // Logger
        logger = new Logger(textview1);
    }
    public void onClick(View arg0){
     	byte[] w;
    	int size = 0;
   	    if (arg0 == button1){
    		try{
            	serverAddress = InetAddress.getByName(server);
            	socket = new DatagramSocket();
     	    	logger.log("Connected");
    		    rcvThread = new Thread(new rcvThread(socket, logger));
    		    rcvThread.start();
    		    logger.log("rcvThread started");
    		} catch (Exception e){
    			logger.log("fail connect");
    		}
    	}
    	if (arg0 == button3){
    		exitFromRunLoop();
    		try{
    			socket.close();
    			socket = null;
    			logger.log("closed");
    		} catch (Exception e) {
    			logger.log("fail close");
    		}
    	}
   		// M
    	if (arg0 == button2){
    		try {
				w = "@w".getBytes("UTF8");//edittext1.getText().toString().getBytes("UTF8");
				size = w.length;    			
    			
				DatagramPacket sendPacket = new DatagramPacket(w, size, serverAddress, port);
				socket.send(sendPacket);
				logger.log("SEND: @w");
			} catch (IOException e) {
				e.printStackTrace();
				logger.log("send fail");
			}
    	}
    	// LED1
    	if (arg0 == button4){
    		try {
    			w = "@r1".getBytes("UTF8");
				size = w.length;    			
				DatagramPacket sendPacket = new DatagramPacket(w, size, serverAddress, port);
				socket.send(sendPacket);
				logger.log("SEND: @r1");
			} catch (IOException e) {
				e.printStackTrace();
				logger.log("send fail");
			}
    	}
    	// LED2
    	if (arg0 == button5){
    		try {
    			w = "@r2".getBytes("UTF8");
				size = w.length;    			
				DatagramPacket sendPacket = new DatagramPacket(w, size, serverAddress, port);
				socket.send(sendPacket);
				logger.log("SEND: @r2");
			} catch (IOException e) {
				e.printStackTrace();
				logger.log("send fail");
			}
    	}
    	// LED3
    	if (arg0 == button6){
    		try {
    			w = "@r3".getBytes("UTF8");
				size = w.length;    			
				DatagramPacket sendPacket = new DatagramPacket(w, size, serverAddress, port);
				socket.send(sendPacket);
				logger.log("SEND: @r3");
			} catch (IOException e) {
				e.printStackTrace();
				logger.log("send fail");
			}
    	}
    	// LED2
    	if (arg0 == button7){
    		try {
    			w = "@r4".getBytes("UTF8");
				size = w.length;    			
				DatagramPacket sendPacket = new DatagramPacket(w, size, serverAddress, port);
				socket.send(sendPacket);
				logger.log("SEND: @r4");
			} catch (IOException e) {
				e.printStackTrace();
				logger.log("send fail");
			}
    	}
    	
    }
    // Run[vEo
    void exitFromRunLoop(){
    	try {
    		byte[] w = new byte[2];
    		w[0] = magic1;
    		w[1] = magic2;
			DatagramPacket sendPacket = new DatagramPacket(w, w.length, serverAddress, port);
    		socket.send(sendPacket);
    		logger.log(new String(w, 0,2, "UTF8"));
    	} catch (IOException e) {
    		logger.log("send fail");
    		e.printStackTrace();
    	}
    }
}